;Program compiled by Great Cow BASIC (0.9 4/12/2007)
;Need help? See the GCBASIC forums at http://sourceforge.net/forum/?group_id=169286,
;check the documentation or email hconsidine@bigpond.com.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=16F84A, r=DEC
#include <P16F84A.inc>
 __CONFIG _XT_OSC & _WDT_OFF

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	equ	12
DELAYTEMP2	equ	13
SysIntOffCount	equ	14
SysSTATUS	equ	15
SysW	equ	16
SysWaitTemp10US	equ	17
SysWaitTempMS	equ	18
SysWaitTempMS_H	equ	19
TMR0PRES	equ	20
TMR0SOURCE	equ	21

;********************************************************************************

;Jump to initialisation code when PIC is reset
	ORG	0
	call	INITSYS
	goto	SystemInitialise

;********************************************************************************

;Interrupt vector
	ORG	4
;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	clrf	SysIntOffCount
	incf	SysIntOffCount,F
;Call Interrupt sub
	goto	INTERRUPT
INTERRUPTDONE
;Restore Context
	clrf	SysIntOffCount
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie

;********************************************************************************

;Various initialisation routines, automatically called by GCBASIC
SystemInitialise

;********************************************************************************

;Start of the main program
STARTUP
	movlw	10
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
TIME_INT
	movlw	1
	movwf	TMR0SOURCE
	movlw	3
	movwf	TMR0PRES
	call	INITTIMER0
	bsf	INTCON,GIE
	bsf	INTCON,T0IE
	bcf	INTCON,T0IF
MAIN
	banksel	TRISA
	clrf	TRISA
SysDoLoop_S1
	movlw	1
	banksel	PORTA
	movwf	PORTA
	movlw	90
	movwf	SysWaitTemp10US
	call	Delay_10US
	clrf	PORTA
	movlw	90
	movwf	SysWaitTemp10US
	call	Delay_10US
	goto	SysDoLoop_S1
SysDoLoop_E1
	goto	MAIN
BASPROGRAMEND
	sleep
	goto	$

;********************************************************************************

; User interrupt routine
INTERRUPT
	bcf	INTCON,T0IF
	goto	INTERRUPTDONE

;********************************************************************************
;Subroutines included in program
;********************************************************************************

Delay_10US
D10US_START
	movlw	3
	movwf	DELAYTEMP
D10US_LOOP
	decfsz	DELAYTEMP, F
	goto	D10US_LOOP
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	10
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	33
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
	clrf	PORTA
	clrf	PORTB
	return

;********************************************************************************

INITTIMER0
	call	SINITTIMER0
	return

;********************************************************************************

SINITTIMER0
	movlw	192
	banksel	OPTION_REG
	andwf	OPTION_REG,F
	bcf	OPTION_REG,PSA
	movlw	1
	banksel	TMR0SOURCE
	subwf	TMR0SOURCE,W
	btfss	STATUS, Z
	goto	ENDIF1
	banksel	OPTION_REG
	bcf	OPTION_REG,T0SE
ENDIF1
	movlw	2
	banksel	TMR0SOURCE
	subwf	TMR0SOURCE,W
	btfss	STATUS, Z
	goto	ENDIF2
	banksel	OPTION_REG
	bsf	OPTION_REG,T0SE
ENDIF2
	clrwdt
	movf	OPTION_REG,W
	banksel	TMR0PRES
	iorwf	TMR0PRES,W
	banksel	OPTION_REG
	movwf	OPTION_REG
	banksel	STATUS
	return

;********************************************************************************

 END
